import { isDate, isValidDate } from "../../libs/types.mjs";
import { RULE, ValueSchemaError } from "../../libs/ValueSchemaError.mjs";
/**
 * apply schema
 * @param values input/output values
 * @param _rules rules
 * @param keyStack key stack for error handling
 * @returns escapes from applyTo chain or not
 */
export function applyTo(values, _rules, keyStack) {
  if (!isDate(values.output)) {
    // could not convert to Date
    return ValueSchemaError.raise(RULE.TYPE, values, keyStack);
  }
  if (!isValidDate(values.output)) {
    // could convert to Date, but invalid.
    // mostly, the format is wrong.
    return ValueSchemaError.raise(RULE.PATTERN, values, keyStack);
  }
  // copy value
  values.output = new Date(values.output);
  return false;
}